<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
  <html>
  <body>
    <h2>Book Catalog</h2>
    <h3>Books in different categories shown in different colors</h3>
    <table border="1">
    <tr>
      <th align="left">Author</th>
      <th align="left">Title</th>
      <th align="left">Price</th>
    </tr>
    <xsl:for-each select='books/book'>
    <xsl:sort select="@category"/>
    <xsl:sort select="author"/>
    <xsl:sort select="price" data-type="number"/>
    <xsl:choose>
      <xsl:when test="@category = 'CHILDREN'">
        <tr bgcolor="#ff00ff">
          <td><xsl:value-of select="author"/></td>
          <td><xsl:value-of select="title"/></td>
          <td><xsl:value-of select="price"/></td>
        </tr>
      </xsl:when>
      <xsl:when test="@category = 'COMPUTING'">
        <tr bgcolor="#00ffff">
          <td><xsl:value-of select="author"/></td>
          <td><xsl:value-of select="title"/></td>
          <td><xsl:value-of select="price"/></td>
        </tr>
      </xsl:when>
      <xsl:when test="@category = 'SCIENCE'">
        <tr bgcolor="#ffff00">
          <td><xsl:value-of select="author"/></td>
          <td><xsl:value-of select="title"/></td>
          <td><xsl:value-of select="price"/></td>
        </tr>
      </xsl:when>
      <xsl:otherwise>
        <tr>
          <td><xsl:value-of select="author"/></td>
          <td><xsl:value-of select="title"/></td>
          <td><xsl:value-of select="price"/></td>
        </tr>
      </xsl:otherwise>
    </xsl:choose>
    </xsl:for-each>
    </table>
  </body>
  </html>
</xsl:template>

</xsl:stylesheet>
